Index: include/asterisk/logger.h
===================================================================
--- include/asterisk/logger.h	(.../branches/11)	(revision 385989)
+++ include/asterisk/logger.h	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -209,8 +209,19 @@
 #endif
 #define AST_LOG_DTMF    __LOG_DTMF, _A_
 
-#define NUMLOGLEVELS 32
+#ifdef LOG_CQR
+#undef LOG_CQR
+#endif
+#define __LOG_CQR  7
+#define LOG_CQR    __LOG_CQR, _A_
 
+#ifdef AST_LOG_CQR
+#undef AST_LOG_CQR
+#endif
+#define AST_LOG_CQR    __LOG_CQR, _A_
+
+#define NUMLOGLEVELS 64		/* Highest bit */
+
 /*!
  * \brief Get the debug level for a module
  * \param module the name of module
Index: include/asterisk/autoconfig.h.in
===================================================================
--- include/asterisk/autoconfig.h.in	(.../branches/11)	(revision 385989)
+++ include/asterisk/autoconfig.h.in	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -1016,9 +1016,6 @@
 /* Define to 1 if `utime(file, NULL)' sets file's timestamp to the present. */
 #undef HAVE_UTIME_NULL
 
-/* Define to 1 if you have the UUID library. */
-#undef HAVE_UUID
-
 /* Define to 1 if your system can support larger than default select bitmasks.
    */
 #undef HAVE_VARIABLE_FDSET
@@ -1229,6 +1226,11 @@
 /* Define to 1 if running on Darwin. */
 #undef _DARWIN_UNLIMITED_SELECT
 
+/* Enable large inode numbers on Mac OS X 10.5.  */
+#ifndef _DARWIN_USE_64_BIT_INODE
+# define _DARWIN_USE_64_BIT_INODE 1
+#endif
+
 /* Number of bits in a file offset, on hosts where this is settable. */
 #undef _FILE_OFFSET_BITS
 
Index: main/cdr.c
===================================================================
--- main/cdr.c	(.../branches/11)	(revision 385989)
+++ main/cdr.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -115,8 +115,6 @@
 static int batchsafeshutdown;
 static const int BATCH_SAFE_SHUTDOWN_DEFAULT = 1;
 
-AST_MUTEX_DEFINE_STATIC(cdr_sched_lock);
-
 AST_MUTEX_DEFINE_STATIC(cdr_batch_lock);
 
 /* these are used to wake up the CDR thread when there's work to do */
@@ -1351,24 +1349,17 @@
 {
 	ast_cdr_submit_batch(0);
 	/* manually reschedule from this point in time */
-	ast_mutex_lock(&cdr_sched_lock);
 	cdr_sched = ast_sched_add(sched, batchtime * 1000, submit_scheduled_batch, NULL);
-	ast_mutex_unlock(&cdr_sched_lock);
 	/* returning zero so the scheduler does not automatically reschedule */
 	return 0;
 }
 
-/*! Do not hold the batch lock while calling this function */
 static void submit_unscheduled_batch(void)
 {
-	/* Prevent two deletes from happening at the same time */
-	ast_mutex_lock(&cdr_sched_lock);
 	/* this is okay since we are not being called from within the scheduler */
 	AST_SCHED_DEL(sched, cdr_sched);
 	/* schedule the submission to occur ASAP (1 ms) */
 	cdr_sched = ast_sched_add(sched, 1, submit_scheduled_batch, NULL);
-	ast_mutex_unlock(&cdr_sched_lock);
-
 	/* signal the do_cdr thread to wakeup early and do some work (that lazy thread ;) */
 	ast_mutex_lock(&cdr_pending_lock);
 	ast_cond_signal(&cdr_pending_cond);
@@ -1379,7 +1370,6 @@
 {
 	struct ast_cdr_batch_item *newtail;
 	int curr;
-	int submit_batch = 0;
 
 	if (!cdr)
 		return;
@@ -1426,14 +1416,10 @@
 
 	/* if we have enough stuff to post, then do it */
 	if (curr >= (batchsize - 1)) {
-		submit_batch = 1;
+		submit_unscheduled_batch();
 	}
+
 	ast_mutex_unlock(&cdr_batch_lock);
-
-	/* Don't call submit_unscheduled_batch with the cdr_batch_lock held */
-	if (submit_batch) {
-		submit_unscheduled_batch();
-	}
 }
 
 static void *do_cdr(void *data)
@@ -1579,9 +1565,7 @@
 	}
 
 	/* don't run the next scheduled CDR posting while reloading */
-	ast_mutex_lock(&cdr_sched_lock);
 	AST_SCHED_DEL(sched, cdr_sched);
-	ast_mutex_unlock(&cdr_sched_lock);
 
 	for (v = ast_variable_browse(config, "general"); v; v = v->next) {
 		if (!strcasecmp(v->name, "enable")) {
@@ -1622,9 +1606,7 @@
 	if (enabled && !batchmode) {
 		ast_log(LOG_NOTICE, "CDR simple logging enabled.\n");
 	} else if (enabled && batchmode) {
-		ast_mutex_lock(&cdr_sched_lock);
 		cdr_sched = ast_sched_add(sched, batchtime * 1000, submit_scheduled_batch, NULL);
-		ast_mutex_unlock(&cdr_sched_lock);
 		ast_log(LOG_NOTICE, "CDR batch mode logging enabled, first of either size %d or time %d seconds.\n", batchsize, batchtime);
 	} else {
 		ast_log(LOG_NOTICE, "CDR logging disabled, data will be lost.\n");
@@ -1636,9 +1618,7 @@
 		ast_cond_init(&cdr_pending_cond, NULL);
 		if (ast_pthread_create_background(&cdr_thread, NULL, do_cdr, NULL) < 0) {
 			ast_log(LOG_ERROR, "Unable to start CDR thread.\n");
-			ast_mutex_lock(&cdr_sched_lock);
 			AST_SCHED_DEL(sched, cdr_sched);
-			ast_mutex_unlock(&cdr_sched_lock);
 		} else {
 			ast_cli_register(&cli_submit);
 			ast_register_atexit(ast_cdr_engine_term);
Index: main/manager.c
===================================================================
--- main/manager.c	(.../branches/11)	(revision 385989)
+++ main/manager.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -7563,15 +7563,7 @@
 	for (var = ast_variable_browse(cfg, "general"); var; var = var->next) {
 		val = var->value;
 
-		/* read tls config options while preventing unsupported options from being set */
-		if (strcasecmp(var->name, "tlscafile")
-			&& strcasecmp(var->name, "tlscapath")
-			&& strcasecmp(var->name, "tlscadir")
-			&& strcasecmp(var->name, "tlsverifyclient")
-			&& strcasecmp(var->name, "tlsdontverifyserver")
-			&& strcasecmp(var->name, "tlsclientmethod")
-			&& strcasecmp(var->name, "sslclientmethod")
-			&& !ast_tls_read_conf(&ami_tls_cfg, &amis_desc, var->name, val)) {
+		if (!ast_tls_read_conf(&ami_tls_cfg, &amis_desc, var->name, val)) {
 			continue;
 		}
 
Index: main/http.c
===================================================================
--- main/http.c	(.../branches/11)	(revision 385989)
+++ main/http.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -229,7 +229,7 @@
 		goto out403;
 	}
 
-	/* Disallow any funny filenames at all (checking first character only??) */
+	/* Disallow any funny filenames at all */
 	if ((uri[0] < 33) || strchr("./|~@#$%^&*() \t", uri[0])) {
 		goto out403;
 	}
@@ -244,7 +244,6 @@
 
 	if (!(mtype = ast_http_ftype2mtype(ftype))) {
 		snprintf(wkspace, sizeof(wkspace), "text/%s", S_OR(ftype, "plain"));
-		mtype = wkspace;
 	}
 
 	/* Cap maximum length */
@@ -262,12 +261,12 @@
 		goto out404;
 	}
 
-	if (strstr(path, "/private/") && !astman_is_authed(ast_http_manid_from_vars(headers))) {
+	fd = open(path, O_RDONLY);
+	if (fd < 0) {
 		goto out403;
 	}
 
-	fd = open(path, O_RDONLY);
-	if (fd < 0) {
+	if (strstr(path, "/private/") && !astman_is_authed(ast_http_manid_from_vars(headers))) {
 		goto out403;
 	}
 
@@ -290,7 +289,6 @@
 	}
 
 	if ( (http_header = ast_str_create(255)) == NULL) {
-		close(fd);
 		return -1;
 	}
 
@@ -595,8 +593,6 @@
 	AST_RWLIST_UNLOCK(&uris);
 }
 
-#define MAX_POST_CONTENT 1025
-
 /*
  * get post variables from client Request Entity-Body, if content type is
  * application/x-www-form-urlencoded
@@ -629,13 +625,6 @@
 		return NULL;
 	}
 
-	if (content_length > MAX_POST_CONTENT - 1) {
-		ast_log(LOG_WARNING, "Excessively long HTTP content. %d is greater than our max of %d\n",
-				content_length, MAX_POST_CONTENT);
-		ast_http_send(ser, AST_HTTP_POST, 413, "Request Entity Too Large", NULL, NULL, 0, 0);
-		return NULL;
-	}
-
 	buf = ast_malloc(content_length + 1);
 	if (!buf) {
 		return NULL;
@@ -1063,17 +1052,8 @@
 		v = ast_variable_browse(cfg, "general");
 		for (; v; v = v->next) {
 
-			/* read tls config options while preventing unsupported options from being set */
-			if (strcasecmp(v->name, "tlscafile")
-				&& strcasecmp(v->name, "tlscapath")
-				&& strcasecmp(v->name, "tlscadir")
-				&& strcasecmp(v->name, "tlsverifyclient")
-				&& strcasecmp(v->name, "tlsdontverifyserver")
-				&& strcasecmp(v->name, "tlsclientmethod")
-				&& strcasecmp(v->name, "sslclientmethod")
-				&& strcasecmp(v->name, "tlscipher")
-				&& strcasecmp(v->name, "sslcipher")
-				&& !ast_tls_read_conf(&http_tls_cfg, &https_desc, v->name, v->value)) {
+			/* handle tls conf */
+			if (!ast_tls_read_conf(&http_tls_cfg, &https_desc, v->name, v->value)) {
 				continue;
 			}
 
Index: main/devicestate.c
===================================================================
--- main/devicestate.c	(.../branches/11)	(revision 385989)
+++ main/devicestate.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -705,7 +705,7 @@
 static void devstate_change_collector_cb(const struct ast_event *event, void *data)
 {
 	struct devstate_change *sc;
-	const char *device, *cachable_str;
+	const char *device;
 	const struct ast_eid *eid;
 	uint32_t state;
 	enum ast_devstate_cache cachable = AST_DEVSTATE_CACHABLE;
@@ -713,6 +713,7 @@
 	device = ast_event_get_ie_str(event, AST_EVENT_IE_DEVICE);
 	eid = ast_event_get_ie_raw(event, AST_EVENT_IE_EID);
 	state = ast_event_get_ie_uint(event, AST_EVENT_IE_STATE);
+	cachable = ast_event_get_ie_uint(event, AST_EVENT_IE_CACHABLE);
 
 	if (ast_strlen_zero(device) || !eid) {
 		ast_log(LOG_ERROR, "Invalid device state change event received\n");
@@ -725,16 +726,6 @@
 	strcpy(sc->device, device);
 	sc->eid = *eid;
 	sc->state = state;
-
-	/* For 'cachable' we cannot use ast_event_get_ie_uint(), it overwrites the default of AST_DEVSTATE_CACHABLE we
-	 * have already setup for 'cachable', if for whatever reason the AST_EVENT_IE_CACHABLE wasn't
-	 * posted in the event ast_event_get_ie_uint() is going will return 0,
-	 * which equates to AST_DEVSTATE_NOT_CACHABLE the first enumeration in 'ast_devstate_cache'.
-	 */
-
-	if ((cachable_str = ast_event_get_ie_str(event, AST_EVENT_IE_CACHABLE))) {
-		sscanf(cachable_str, "%30u", &cachable);
-	}
 	sc->cachable = cachable;
 
 	ast_mutex_lock(&devstate_collector.lock);
Index: main/format_pref.c
===================================================================
--- main/format_pref.c	(.../branches/11)	(revision 385989)
+++ main/format_pref.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -317,7 +317,7 @@
 /*! \brief Pick a codec */
 struct ast_format *ast_codec_choose(struct ast_codec_pref *pref, struct ast_format_cap *cap, int find_best, struct ast_format *result)
 {
-	int x, slot, found = 0;
+	int x, slot, found;
 	size_t f_len = 0;
 	const struct ast_format_list *f_list = ast_format_list_get(&f_len);
 
Index: main/logger.c
===================================================================
--- main/logger.c	(.../branches/11)	(revision 385989)
+++ main/logger.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -191,6 +191,7 @@
 	"ERROR",
 	"VERBOSE",
 	"DTMF",
+	"CQR",
 };
 
 /*! \brief Colors used in the console for logging */
@@ -202,6 +203,7 @@
 	COLOR_RED,
 	COLOR_GREEN,
 	COLOR_BRGREEN,
+	COLOR_BRBLUE,
 	0,
 	0,
 	0,
@@ -210,7 +212,6 @@
 	0,
 	0,
 	0,
-	0,
 	COLOR_BRBLUE,
 	COLOR_BRBLUE,
 	COLOR_BRBLUE,
Index: main/tcptls.c
===================================================================
--- main/tcptls.c	(.../branches/11)	(revision 385989)
+++ main/tcptls.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -373,11 +373,6 @@
 		cfg->enabled = 0;
 		return 0;
 	}
-
-	SSL_CTX_set_verify(cfg->ssl_ctx,
-		ast_test_flag(&cfg->flags, AST_SSL_VERIFY_CLIENT) ? SSL_VERIFY_PEER | SSL_VERIFY_FAIL_IF_NO_PEER_CERT : SSL_VERIFY_NONE,
-		NULL);
-
 	if (!ast_strlen_zero(cfg->certfile)) {
 		char *tmpprivate = ast_strlen_zero(cfg->pvtfile) ? cfg->certfile : cfg->pvtfile;
 		if (SSL_CTX_use_certificate_file(cfg->ssl_ctx, cfg->certfile, SSL_FILETYPE_PEM) == 0) {
Index: main/rtp_engine.c
===================================================================
--- main/rtp_engine.c	(.../branches/11)	(revision 385989)
+++ main/rtp_engine.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -21,6 +21,9 @@
  * \brief Pluggable RTP Architecture
  *
  * \author Joshua Colp <jcolp@digium.com>
+ *
+ * Improved RTCP support by
+ * \author Olle E. Johansson  <oej@edvina.net>
  */
 
 /*** MODULEINFO
@@ -915,6 +918,13 @@
 	return instance->engine->qos ? instance->engine->qos(instance, tos, cos, desc) : -1;
 }
 
+void ast_rtp_instance_hold(struct ast_rtp_instance *instance, int status)
+{
+	if (instance->engine->hold) {
+		instance->engine->hold(instance, status);
+	}
+}
+
 void ast_rtp_instance_stop(struct ast_rtp_instance *instance)
 {
 	if (instance->engine->stop) {
@@ -968,6 +978,7 @@
 		return AST_BRIDGE_FAILED_NOWARN;
 	}
 
+	/* Now let go of the channel locks and be on our way */
 	ast_channel_unlock(c0);
 	ast_channel_unlock(c1);
 
@@ -976,6 +987,10 @@
 
 	ast_poll_channel_add(c0, c1);
 
+	/* Kick the RTCP stream going by sending one empty stupid little packet */
+	ast_rtcp_write_empty(instance0);
+	ast_rtcp_write_empty(instance1);
+
 	/* Hop into a loop waiting for a frame from either channel */
 	cs[0] = c0;
 	cs[1] = c1;
@@ -2065,6 +2080,56 @@
 	return instance->srtp;
 }
 
+
+int ast_rtp_instance_isactive(struct ast_rtp_instance *instance)
+{
+	if (instance->engine->isactive) {
+ 		return instance->engine->isactive(instance);
+ 	}
+	return -1;
+}
+ 
+int ast_rtcp_write_empty(struct ast_rtp_instance *instance)
+{
+	if (instance->engine->rtcp_write_empty) {
+		instance->engine->rtcp_write_empty(instance);
+		return 0;
+	}
+	return -1;
+}
+
+int ast_rtp_instance_setcname(struct ast_rtp_instance *instance, const char *cname, size_t length)
+{
+	if (instance->engine->setcname) {
+		instance->engine->setcname(instance, cname, length);
+		return 0;
+	}
+
+	return -1;	/* Function does not exist */
+}
+
+int ast_rtp_instance_set_bridged_chan(struct ast_rtp_instance *instance, const char *channel, const char *uniqueid, const char *bridgedchan, const char *bridgeduniqueid)
+{
+	if (instance->engine->set_bridged_chan) {
+		instance->engine->set_bridged_chan(instance, channel, uniqueid, bridgedchan, bridgeduniqueid);
+		return 0;
+	}
+
+	return -1;	/* Function does not exist */
+}
+
+
+int ast_rtp_instance_set_translator(struct ast_rtp_instance *instance, const char *readtranslator, const int readcost, const char *writetranslator, const int writecost)
+{
+	if (instance->engine->set_translator) {
+		instance->engine->set_translator(instance, readtranslator, readcost, writetranslator, writecost);
+		return 0;
+	}
+
+	return -1;	/* Function does not exist */
+}
+ 
+
 int ast_rtp_instance_sendcng(struct ast_rtp_instance *instance, int level)
 {
 	if (instance->engine->sendcng) {
Index: configs/cli_aliases.conf.sample
===================================================================
--- configs/cli_aliases.conf.sample	(.../branches/11)	(revision 385989)
+++ configs/cli_aliases.conf.sample	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -26,7 +26,7 @@
 hangup request=channel request hangup
 originate=channel originate
 help=core show help
-pri intense debug span=pri set debug intense span
+pri intense debug span=pri set debug 2 span
 reload=module reload
 
 ; CLI Alias Templates
Index: configs/chan_dahdi.conf.sample
===================================================================
--- configs/chan_dahdi.conf.sample	(.../branches/11)	(revision 385989)
+++ configs/chan_dahdi.conf.sample	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -196,18 +196,6 @@
 ;
 ;resetinterval = 3600
 ;
-; Assume inband audio may be present when a PROCEEDING message is received.
-; Q.931 Section 5.1.2 says the network cannot assume that the CPE side has
-; attached to the B channel at this time without explicitly sending the
-; progress indicator ie informing the CPE side to attach to the B channel
-; for audio.  However, some non-compliant ISDN switches send a PROCEEDING
-; without the progress indicator ie indicating inband audio is available and
-; assume that the CPE device has connected the media path for listening to
-; ringback and other messages.
-; Default yes in current release branches for backward compatibility.
-;
-;inband_on_proceeding=yes
-;
 ; Overlap dialing mode (sending overlap digits)
 ; Cannot be changed on a reload.
 ;
Index: configs/extconfig.conf.sample
===================================================================
--- configs/extconfig.conf.sample	(.../branches/11)	(revision 385989)
+++ configs/extconfig.conf.sample	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -58,17 +58,13 @@
 ; start at 1 and be sequential (i.e. if you have only priorities 1, 2,
 ; and 4, then 4 will be ignored, because there is no 3).
 ;
-;
-; Possible driver backends:
-;
 ; "odbc" is shown in the examples below, but is not the only valid realtime
-; engine.  Here are several of the possible options:
+; engine.  There is:
 ;    odbc ... res_config_odbc
 ;    sqlite ... res_config_sqlite
 ;    pgsql ... res_config_pgsql
 ;    curl ... res_config_curl
 ;    ldap ... res_config_ldap
-;    mysql ... res_config_mysql (available via add-ons in menuselect)
 ;
 ; Note: The res_config_pgsql and res_config_sqlite backends configure the
 ; database used in their respective configuration files and ignore the
@@ -86,6 +82,7 @@
 ;acls => odbc,asterisk
 ;musiconhold => mysql,general
 ;queue_log => mysql,general
+;rtpcqr => mysql,general,astcqr	; RTP Call Quality Records
 ;
 ;
 ; While most dynamic realtime engines are automatically used when defined in
Index: makeopts.in
===================================================================
--- makeopts.in	(.../branches/11)	(revision 385989)
+++ makeopts.in	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -283,9 +283,6 @@
 UNIXODBC_INCLUDE=@UNIXODBC_INCLUDE@
 UNIXODBC_LIB=@UNIXODBC_LIB@
 
-UUID_INCLUDE=@UUID_INCLUDE@
-UUID_LIB=@UUID_LIB@
-
 VORBIS_INCLUDE=@VORBIS_INCLUDE@
 VORBIS_LIB=@VORBIS_LIB@
 
Index: res/res_rtp_multicast.c
===================================================================
--- res/res_rtp_multicast.c	(.../branches/11)	(revision 385989)
+++ res/res_rtp_multicast.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -90,8 +90,6 @@
 	unsigned int ssrc;
 	/*! Sequence number, used when creating/sending the RTP packet */
 	uint16_t seqno;
-	unsigned int lastts;	
-	struct timeval txcore;
 };
 
 /* Forward Declarations */
@@ -142,30 +140,6 @@
 	return 0;
 }
 
-static int rtp_get_rate(struct ast_format *format)
-{
-        return (format->id == AST_FORMAT_G722) ? 8000 : ast_format_rate(format);
-}
-
-static unsigned int calc_txstamp(struct multicast_rtp *rtp, struct timeval *delivery)
-{
-        struct timeval t;
-        long ms;
-
-        if (ast_tvzero(rtp->txcore)) {
-                rtp->txcore = ast_tvnow();
-                rtp->txcore.tv_usec -= rtp->txcore.tv_usec % 20000;
-        }
-
-        t = (delivery && !ast_tvzero(*delivery)) ? *delivery : ast_tvnow();
-        if ((ms = ast_tvdiff_ms(t, rtp->txcore)) < 0) {
-                ms = 0;
-        }
-        rtp->txcore = t;
-
-        return (unsigned int) ms;
-}
-
 /*! \brief Helper function which populates a control packet with useful information and sends it */
 static int multicast_send_control_packet(struct ast_rtp_instance *instance, struct multicast_rtp *multicast, int command)
 {
@@ -236,8 +210,6 @@
 	struct ast_sockaddr remote_address;
 	int hdrlen = 12, res = 0, codec;
 	unsigned char *rtpheader;
-	unsigned int ms = calc_txstamp(multicast, &frame->delivery);
-	int rate = rtp_get_rate(&frame->subclass.format) / 1000;
 
 	/* We only accept audio, nothing else */
 	if (frame->frametype != AST_FRAME_VOICE) {
@@ -253,21 +225,12 @@
 	if (frame->offset < hdrlen) {
 		f = ast_frdup(frame);
 	}
-	
-	/* Calucate last TS */
-	multicast->lastts = multicast->lastts + ms * rate;
-	
+
 	/* Construct an RTP header for our packet */
 	rtpheader = (unsigned char *)(f->data.ptr - hdrlen);
 	put_unaligned_uint32(rtpheader, htonl((2 << 30) | (codec << 16) | (multicast->seqno)));
-	put_unaligned_uint32(rtpheader + 4, htonl(multicast->lastts));
-	
-	if (ast_test_flag(f, AST_FRFLAG_HAS_TIMING_INFO)) {
-		put_unaligned_uint32(rtpheader + 4, htonl(f->ts * 8));
-	} 
-	else {
-		put_unaligned_uint32(rtpheader + 8, htonl(multicast->ssrc));
-	}
+	put_unaligned_uint32(rtpheader + 4, htonl(f->ts * 8));
+	put_unaligned_uint32(rtpheader + 8, htonl(multicast->ssrc));
 
 	/* Increment sequence number and wrap to 0 if it overflows 16 bits. */
 	multicast->seqno = 0xFFFF & (multicast->seqno + 1);

Index: res/res_config_ldap.c
===================================================================
--- res/res_config_ldap.c	(.../branches/11)	(revision 385989)
+++ res/res_config_ldap.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -1236,14 +1236,14 @@
 	}
 
 	mods_size = 2; /* one for the first param/value pair and one for the the terminating NULL */
-	ldap_mods = ldap_memcalloc(sizeof(LDAPMod *), mods_size);
-	ldap_mods[0] = ldap_memcalloc(1, sizeof(LDAPMod));
+	ldap_mods = ast_calloc(sizeof(LDAPMod *), mods_size);
+	ldap_mods[0] = ast_calloc(1, sizeof(LDAPMod));
 
 	ldap_mods[0]->mod_op = LDAP_MOD_REPLACE;
-	ldap_mods[0]->mod_type = ldap_strdup(newparam);
+	ldap_mods[0]->mod_type = ast_strdup(newparam);
 
 	ldap_mods[0]->mod_values = ast_calloc(sizeof(char *), 2);
-	ldap_mods[0]->mod_values[0] = ldap_strdup(newval);
+	ldap_mods[0]->mod_values[0] = ast_strdup(newval);
 
 	while ((newparam = va_arg(ap, const char *))) {
 		newparam = convert_attribute_name_to_ldap(table_config, newparam);
@@ -1253,7 +1253,7 @@
 		for (i = 0; i < mods_size - 1; i++) {
 			if (ldap_mods[i]&& !strcmp(ldap_mods[i]->mod_type, newparam)) {
 				/* We have the parameter allready, adding the value as a semicolon delimited value */
-				ldap_mods[i]->mod_values[0] = ldap_memrealloc(ldap_mods[i]->mod_values[0], sizeof(char) * (strlen(ldap_mods[i]->mod_values[0]) + strlen(newval) + 2));
+				ldap_mods[i]->mod_values[0] = ast_realloc(ldap_mods[i]->mod_values[0], sizeof(char) * (strlen(ldap_mods[i]->mod_values[0]) + strlen(newval) + 2));
 				strcat(ldap_mods[i]->mod_values[0], ";");
 				strcat(ldap_mods[i]->mod_values[0], newval);
 				mod_exists = 1;	
@@ -1264,12 +1264,12 @@
 		/* create new mod */
 		if (!mod_exists) {
 			mods_size++;
-			ldap_mods = ldap_memrealloc(ldap_mods, sizeof(LDAPMod *) * mods_size);
+			ldap_mods = ast_realloc(ldap_mods, sizeof(LDAPMod *) * mods_size);
 			ldap_mods[mods_size - 1] = NULL;
 			
-			ldap_mods[mods_size - 2] = ldap_memcalloc(1, sizeof(LDAPMod));
+			ldap_mods[mods_size - 2] = ast_calloc(1, sizeof(LDAPMod));
 
-			ldap_mods[mods_size - 2]->mod_type = ldap_memcalloc(sizeof(char), strlen(newparam) + 1);
+			ldap_mods[mods_size - 2]->mod_type = ast_calloc(sizeof(char), strlen(newparam) + 1);
 			strcpy(ldap_mods[mods_size - 2]->mod_type, newparam);
 
 			if (strlen(newval) == 0) {
@@ -1277,8 +1277,8 @@
 			} else {
 				ldap_mods[mods_size - 2]->mod_op = LDAP_MOD_REPLACE;
 
-				ldap_mods[mods_size - 2]->mod_values = ldap_memcalloc(sizeof(char *), 2);
-				ldap_mods[mods_size - 2]->mod_values[0] = ldap_memcalloc(sizeof(char), strlen(newval) + 1);
+				ldap_mods[mods_size - 2]->mod_values = ast_calloc(sizeof(char *), 2);
+				ldap_mods[mods_size - 2]->mod_values[0] = ast_calloc(sizeof(char), strlen(newval) + 1);
 				strcpy(ldap_mods[mods_size - 2]->mod_values[0], newval);
 			}
 		}
Index: res/res_format_attr_h264.c
===================================================================
--- res/res_format_attr_h264.c	(.../branches/11)	(revision 385989)
+++ res/res_format_attr_h264.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -41,14 +41,8 @@
 /*! \brief Value that indicates an attribute is actually unset */
 #define H264_ATTR_KEY_UNSET UINT8_MAX
 
-/*! \brief Maximum size for SPS / PPS values in sprop-parameter-sets attribute
- *   if you change this value then you must change H264_MAX_SPS_PPS_SIZE_SCAN_LIMIT
- *   as well. */
+/*! \brief Maximum size for SPS / PPS values in sprop-parameter-sets attribute */
 #define H264_MAX_SPS_PPS_SIZE 16
-/*! \brief This is used when executing sscanf on buffers of H264_MAX_SPS_PPS_SIZE
- *   length. It must ALWAYS be a string literal representation of one less than
- *   H264_MAX_SPS_PPS_SIZE */
-#define H264_MAX_SPS_PPS_SIZE_SCAN_LIMIT "15"
 
 enum h264_attr_keys {
 	H264_ATTR_KEY_PROFILE_IDC,
@@ -117,8 +111,7 @@
 			format_attr->format_attr[H264_ATTR_KEY_PROFILE_IDC] = ((val2 >> 16) & 0xFF);
 			format_attr->format_attr[H264_ATTR_KEY_PROFILE_IOP] = ((val2 >> 8) & 0xFF);
 			format_attr->format_attr[H264_ATTR_KEY_LEVEL] = (val2 & 0xFF);
-		} else if (sscanf(attrib, "sprop-parameter-sets=%" H264_MAX_SPS_PPS_SIZE_SCAN_LIMIT "[^','],%" H264_MAX_SPS_PPS_SIZE_SCAN_LIMIT "s", sps, pps) == 2) {
-			/* XXX sprop-parameter-sets can actually be of unlimited length. This may need to be addressed later. */
+		} else if (sscanf(attrib, "sprop-parameter-sets=%[^','],%s", sps, pps) == 2) {
 			unsigned char spsdecoded[H264_MAX_SPS_PPS_SIZE] = { 0, }, ppsdecoded[H264_MAX_SPS_PPS_SIZE] = { 0, };
 			int i;
 
